team join players @s[tag=!init]
gamemode adventure @s[tag=!init]

effect give @s minecraft:resistance 5 4 true
effect give @s[tag=night] minecraft:night_vision 20 0 true
effect clear @s[tag=!night] minecraft:night_vision

attribute @s[tag=!init] minecraft:generic.movement_speed modifier add 1-1-1-1-1 speed 0.25 multiply

attribute @s[tag=!init] minecraft:generic.knockback_resistance base set 10

data modify storage cod:inventory Inventory set from entity @s Inventory
data modify storage cod:inventory Pile set from storage cod:inventory Inventory

data remove storage cod:inventory Pile[{Slot:0b}]
data remove storage cod:inventory Pile[{Slot:1b}]
data remove storage cod:inventory Pile[{Slot:2b}]
data remove storage cod:inventory Pile[{Slot:3b}]
data remove storage cod:inventory Pile[{Slot:4b}]
data remove storage cod:inventory Pile[{Slot:5b}]
data remove storage cod:inventory Pile[{Slot:6b}]
data remove storage cod:inventory Pile[{Slot:7b}]
data remove storage cod:inventory Pile[{Slot:8b}]

execute if score #puzzle global matches 1.. if entity @s[gamemode=adventure] unless data storage cod:inventory Pile[26] run function cod:pre_drop
execute unless score #puzzle global matches 1.. if entity @s[gamemode=adventure] unless data storage cod:inventory Pile[24] run function cod:pre_drop

data remove storage cod:inventory Pile[{tag:{inv:1b}}]

execute if entity @s[gamemode=adventure] if data storage cod:inventory Pile[0] run function cod:pre_drop

execute if entity @s[gamemode=adventure] if score #puzzle global matches 1.. unless data storage cod:inventory Inventory[{Slot:9b,tag:{exit:1b}}] if data storage cod:inventory Inventory[0] run function cod:exit
execute if entity @s[gamemode=adventure] if score #puzzle global matches 1.. unless data storage cod:inventory Inventory[{Slot:13b,tag:{restart:1b}}] if data storage cod:inventory Inventory[0] run function cod:restart
execute if entity @s[gamemode=adventure] unless data storage cod:inventory Inventory[{Slot:17b,tag:{night:1b}}] if data storage cod:inventory Inventory[0] run function cod:night

execute if score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.0 with feather{display:{Name:'{"text":"Exit","color":"red","italic":false}'},inv:1b,exit:1b} 1
execute if score #puzzle global matches 1.. run item replace entity @s[gamemode=adventure] inventory.4 with skeleton_skull{display:{Name:'{"text":"Restart","color":"gold","italic":false}'},inv:1b,restart:1b} 1
item replace entity @s[gamemode=adventure] inventory.8 with spyglass{display:{Name:'{"text":"Toggle Night Vision","color":"green","italic":false}'},inv:1b,night:1b} 1

title @s[gamemode=survival] actionbar {"text":"Mechanics will not function in survival mode.","color":"red"}

#multi
execute unless score #puzzle global matches 1.. if entity @s[tag=puzzle] run function cod:unpuzzle

execute positioned ~-0.75 ~ ~-0.75 store result score #playerCount global if entity @a[gamemode=adventure,dx=0.5,dy=1,dz=0.5]
execute if score #playerCount global matches 2.. run function cod:too_close
execute if score #playerCount global matches ..1 if entity @s[tag=close] run function cod:far

execute unless score #puzzle global matches 1.. if predicate cod:sneaking if entity @s[nbt={OnGround:1b}] if predicate cod:red_spawn run tag @s add red
execute unless score #puzzle global matches 1.. if predicate cod:sneaking if entity @s[nbt={OnGround:1b}] if predicate cod:blue_spawn run tag @s add blue
execute unless score #puzzle global matches 1.. if entity @s[tag=red] unless predicate cod:sneaking run tag @s remove red
execute unless score #puzzle global matches 1.. if entity @s[tag=blue] unless predicate cod:sneaking run tag @s remove blue
execute unless score #puzzle global matches 1.. if entity @s[tag=red] unless predicate cod:red_spawn run tag @s remove red
execute unless score #puzzle global matches 1.. if entity @s[tag=blue] unless predicate cod:blue_spawn run tag @s remove blue

execute unless score #puzzle global matches 1.. if entity @s[tag=red] run title @s actionbar "Waiting for other player..."
execute unless score #puzzle global matches 1.. if entity @s[tag=blue] run title @s actionbar "Waiting for other player..."

execute unless score #puzzle global matches 1.. align xyz if entity @s[tag=red] if block ~ ~-3 ~ minecraft:structure_block positioned ~ ~ ~2 if entity @a[tag=blue,dx=0,dy=0,dz=0] positioned ~ ~ ~-1 run function cod:start

execute if score #puzzle global matches 1.. if block ~ ~ ~ #cod:solid run tag @s[gamemode=adventure] add squish
execute if entity @s[tag=limbo] run function cod:limbo
execute if entity @s[tag=squish] run function cod:squish

execute if score #start global matches 1.. run tag @s[tag=!init] add init